package it.unibs.fp.patenteelibbrettopregoh;

import java.util.ArrayList;

public class PaginaDiario {
    private final String data;
    private final double bilancio;
    private final ArrayList<PersonaControllata> personeControllate;

    public PaginaDiario(String data, double bilancio) {
        this.data = data;
        this.bilancio = bilancio;
        this.personeControllate = new ArrayList<>();
    }

    public int getGiorno() {
        return Integer.parseInt(data.split("/")[0]);
    }

    public String getData() {
        return data;
    }

    public double getBilancio() {
        return bilancio;
    }

    public ArrayList<PersonaControllata> getPersoneControllate() {
        return personeControllate;
    }

    public void addPersonaControllata(PersonaControllata persona) {
        this.personeControllate.add(persona);
    }

    public void removePersonaControllata(PersonaControllata persona) {
        this.personeControllate.remove(persona);
    }

}
