package it.unibs.fp.patenteelibbrettopregoh;

public class PersonaControllata extends Persona {
    private final boolean esitoControllo;
    private final TipoPersonaControllata tipoPersonaControllata;

    public PersonaControllata(Persona persona, boolean esitoControllo, TipoPersonaControllata tipoPersonaControllata) {
        super(persona.getNome(), persona.getCognome(), persona.getSesso(), persona.getDataNascita(), persona.getComuneNascita(), persona.getCodiceFiscale(), persona.getScadenzaDocumento());
        this.esitoControllo = esitoControllo;
        this.tipoPersonaControllata = tipoPersonaControllata;
    }

    public boolean isEsitoControllo() {
        return esitoControllo;
    }

    public TipoPersonaControllata getTipoPersonaControllata() {
        return tipoPersonaControllata;
    }

    public String getStatoTransito() {
        return esitoControllo ? "APPROVATO" : "RIFIUTATO";
    }

    @Override
    public String toString() {
        return "Nome: " + getNome() + "\n" +
                "Cognome: " + getCognome() + "\n" +
                "Sesso: " + getSesso() + "\n" +
                "Data di Nascita: " + getDataNascita() + "\n" +
                "Comune di Nascita: " + getComuneNascita() + "\n" +
                "Codice Fiscale: " + getCodiceFiscale() + "\n" +
                "Scadenza Documento: " + getScadenzaDocumento() + "\n" +
                "Esito Controllo: " + (esitoControllo ? "Positivo" : "Negativo") + "\n" +
                "Tipo Persona Controllata: " + tipoPersonaControllata.toString() + "\n";
    }
}
